package com.entropy.david;

import android.content.Context;
import android.content.SharedPreferences;
import android.util.Log;

import com.entropy.david.Letras.Caracter;
import com.entropy.david.Letras.Contador;

import java.util.ArrayList;

/**
 * Created by david on 15/03/2015.
 */
public class AccesoDatos {

    public static Contador getContrasena(Context context) {

        SharedPreferences sh = context.getSharedPreferences("Entrophy clave", Context.MODE_PRIVATE);

        int cuantasLetras = sh.getInt("NumeroLetras", 0);
        Contador cont = new Contador(cuantasLetras);
        Caracter c;


        for (int i = 0; i < cuantasLetras; i++) {

            String[] s = sh.getString("letra " + i, "").split(" ");
            char letra = s[0].charAt(0);
            int color = Integer.parseInt(s[1]);
            int tipoLetra;
            try {
                tipoLetra = Integer.parseInt(s[2]);
            }catch (Exception e){
                tipoLetra = 0;
            }

            c = new Caracter(letra, color, tipoLetra, context);       //hay que usar este en vez del de abajo
            cont.add(c);
        }

        return cont;
    }


    public static Caracter[][] getPosibilidades(Context context) {

        SharedPreferences sh = context.getSharedPreferences("Entrophy", context.MODE_PRIVATE);

        int cuantasLetras = sh.getInt("NumeroLetras", 0);
        if(cuantasLetras == 0) Log.v("Desarrollo", "El numero de letras es 0, falla en \"Resultado getPosibilidades\"");
        Caracter[][] posibilidades = new Caracter[cuantasLetras][];

        for (int i = 0; i < cuantasLetras; i++) {

            int cuantasSubLetras = sh.getInt("subLetra " + i, 0);
            posibilidades[i] = new Caracter[cuantasSubLetras];
            Caracter c;

            for (int j = 0; j < cuantasSubLetras; j++) {

                String s1 = sh.getString("letraSub " + i + " " + j, "Z -16777216");
                String[] s = s1.split(" ");
                char letra = s[0].charAt(0);
                int color = Integer.parseInt(s[1]);
                int tipoLetra = Integer.parseInt(s[2]);

                Log.v("tipoLetra", "el tipo de letra es: "+tipoLetra);                          //borrar

                if (letra == 'Z') {
                    Log.v("La letra es Z:", "indices " + i + " " + j + " " + s1);
                }
                c = new Caracter(letra, color, tipoLetra, context);
                posibilidades[i][j] = c;
            }
        }
        return posibilidades;
    }


    public static long getTiempo(Context c) {
        SharedPreferences sh = c.getSharedPreferences("Entrophy", c.MODE_PRIVATE);
        long tiempo = sh.getLong("tiempoTardado", 0);

        return tiempo;
    }

    public static void guardaPosibilidades(ArrayList<Caracter>[] haSidoPulsando, Context applicationContext) {

        Caracter c;

        for (int i = 0; i < haSidoPulsando.length; i++) {

            int j;
            for (j = 0; j < haSidoPulsando[i].size(); j++) {

                c = haSidoPulsando[i].get(j);

                String letra = c.getValor() + " " + c.getColor() + " " + c.getTipoLetra();
                anade1Posibilidad(letra, i, j, applicationContext);
            }
            anadePosibilidadesNumero(i, haSidoPulsando[i].size(),applicationContext);
        }
    }

    public static void guardaTiempo(long l, Context applicationContext) {

        SharedPreferences sh = applicationContext.getSharedPreferences("Entrophy", applicationContext.MODE_PRIVATE);
        SharedPreferences.Editor ed = sh.edit();

        ed.putLong("tiempoTardado", l);

        ed.commit();

    }

    private static void anadePosibilidadesNumero(int numPulsacion, int numero, Context applicationContext) {

        SharedPreferences sh = applicationContext.getSharedPreferences("Entrophy", applicationContext.MODE_PRIVATE);
        SharedPreferences.Editor ed = sh.edit();

        ed.putInt("subLetra " + numPulsacion, numero);

        ed.commit();
    }

    private static void anade1Posibilidad(String letra, int numPulsacion, int numero, Context applicationContext) {

        SharedPreferences sh = applicationContext.getSharedPreferences("Entrophy", applicationContext.MODE_PRIVATE);
        SharedPreferences.Editor ed = sh.edit();

        ed.putString("letraSub " + numPulsacion + " " + numero, letra);

        ed.commit();

    }

    public static void reseteaSharedPref(int numeroLetrasContraseña, Context applicationContext) {

        SharedPreferences sh = applicationContext.getSharedPreferences("Entrophy", applicationContext.MODE_PRIVATE);
        SharedPreferences.Editor ed = sh.edit();

        ed.clear();
        ed.commit();

        ed.putInt("NumeroLetras", numeroLetrasContraseña);

        ed.commit();
    }



    public static void guardaContrasena(Contador contador, Context applicationContext) {

        SharedPreferences sh = applicationContext.getSharedPreferences("Entrophy clave", applicationContext.MODE_PRIVATE);
        SharedPreferences.Editor ed = sh.edit();


        ed.putInt("NumeroLetras", contador.size());
        String[] letras = new String[contador.size()];
        Caracter c;


        for(int i = 0; i< contador.size(); i++){
            c = contador.get(i);
            letras[i] = c.getValor()+" "+c.getColor()+" "+c.getTipoLetra();

            ed.putString("letra " +i, letras[i]);
        }
        ed.commit();
    }


    public static void señalizar(Context applicationContext) {

        SharedPreferences sh = applicationContext.getSharedPreferences("Entrophy senala", applicationContext.MODE_PRIVATE);
        SharedPreferences.Editor ed = sh.edit();

        ed.putBoolean("senal", true);
        ed.commit();
        Log.v("Desarrollo", "señalizado "+isSeñalar(applicationContext));
    }

    public static void desSeñalizar(Context applicationContext) {

        SharedPreferences sh = applicationContext.getSharedPreferences("Entrophy senala", applicationContext.MODE_PRIVATE);
        SharedPreferences.Editor ed = sh.edit();

        ed.putBoolean("senal", false);
        ed.commit();
        Log.v("Desarrollo", "desSeñalizado "+ isSeñalar(applicationContext));
    }

    public static boolean isSeñalar(Context context){

        SharedPreferences sh = context.getSharedPreferences("Entrophy senala", context.MODE_PRIVATE);
        boolean isSeñala = sh.getBoolean("senal", true);
        Log.v("Desarrollo", "isSeñala vale "+ isSeñala);
        return isSeñala;
    }

    public static void señalaMoverContrasña(Context applicationContext) {

        SharedPreferences sh = applicationContext.getSharedPreferences("Entrophy senala", applicationContext.MODE_PRIVATE);
        SharedPreferences.Editor ed = sh.edit();

        ed.putBoolean("moverContraseña", true);
        ed.commit();
        Log.v("Desarrollo", "señalizado isMoverContraseña"+isSeñalar(applicationContext));
    }

    public static void desseñalaMoverContrasña(Context applicationContext) {

        SharedPreferences sh = applicationContext.getSharedPreferences("Entrophy senala", applicationContext.MODE_PRIVATE);
        SharedPreferences.Editor ed = sh.edit();

        ed.putBoolean("moverContraseña", false);
        ed.commit();
        Log.v("Desarrollo", "desSeñalizado isMoverContraseña"+ isSeñalar(applicationContext));
    }

    public static boolean isMoverEnContraseña(Context context) {

        SharedPreferences sh = context.getSharedPreferences("Entrophy senala", context.MODE_PRIVATE);
        boolean isSeñala = sh.getBoolean("moverContraseña", true);
        Log.v("Desarrollo", "isMoverContraseña vale "+ isSeñala);
        return isSeñala;

    }

    public static void setVelocidad(Context applicationContext, int velocidad) {

        SharedPreferences sh = applicationContext.getSharedPreferences("Entrophy senala", applicationContext.MODE_PRIVATE);
        SharedPreferences.Editor ed = sh.edit();

        ed.putInt("velocidad", velocidad);
        ed.commit();
        Log.v("Desarrollo", "fijada velocidad a: "+velocidad);
    }

    public static int getVelocidad(Context context) {

        SharedPreferences sh = context.getSharedPreferences("Entrophy senala", context.MODE_PRIVATE);
        int velocidad = sh.getInt("velocidad", 5);                              //cambiar la por defecto a 5
        Log.v("Desarrollo", "la velocidad es: "+ velocidad);
        return velocidad;
    }
}
