package com.entropy.david;

import android.annotation.TargetApi;
import android.content.Context;
import android.os.AsyncTask;
import android.os.Build;
import android.util.Log;

import com.entropy.david.Letras.Caracter;
import com.entropy.david.Manejadores.Manejador;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;

/**
 * Created by david on 19/05/2014.
 */
@TargetApi(Build.VERSION_CODES.HONEYCOMB)
public class BucleAsincrono extends AsyncTask<Object, Object, Object> {

    private Caracter[] letras;
    private int tiempo;
    private int tiempoPulsacionAnterior;
    private int pausaInicial;
    private Manejador[] manejador;
    int velocidad;

    public BucleAsincrono(Caracter[] letras, Manejador[] manejador, Context context) {
        this.letras = letras;
        this.manejador = manejador;
        tiempo = 0;
        pausaInicial = 0;
        tiempoPulsacionAnterior = 0;

        velocidad = AccesoDatos.getVelocidad(context);
        if(velocidad != 0) {
//            velocidad = 57 * 5 / velocidad;
            velocidad = 32 * 5 / velocidad;
        }
    }

    @Override
    protected Object doInBackground(Object... params) {

        Log.v("Desarrollo", "primera pulsacion hecha");
        if(pausaInicial != 0) {
            espera(pausaInicial, "fallo en la espera inicial");
        }

        //bucle del programa
        while (true) {

            espera(velocidad, "fallo en el bucleAsincrono");   //para letras sueltas

            //bucle cancelado
            if (isCancelled()) {
                break;
            }
            else{
                publishProgress();
            }

        }
        return null;
    }

    @Override
    protected void onProgressUpdate(Object... params) {
        super.onProgressUpdate();

        if(!isCancelled()) {

            //mueve las letras
            if (letras != null) {
                for (int i = 0; i < letras.length; i++) {
                    letras[i].mueve();
                }
            }

            //mueve los manejadores
            if (manejador != null) {
                for (int i = 0; i < manejador.length; i++) {
                    if (manejador[i] != null)
                        manejador[i].mueve();
                }
            }

            Log.d("mueve", "mueve");

            //actualiza el tiempo
            tiempo++;
        }
    }

    private void espera(int tiempoMilis, String mensaje) {
        try {
            Thread.sleep(tiempoMilis);
        } catch (InterruptedException e) {
            e.printStackTrace();
            Log.v("Fallo", mensaje);
        }
    }

    public int getTiempo() {
        return tiempo;
    }


    public boolean pulsacionValida() {

        //espera entre pulsaciones
        if (tiempoPulsacionAnterior + 3 < getTiempo()) {

            Log.v("tiempo", "tiempo: " +
                            tiempoPulsacionAnterior + " " +
                            getTiempo() + " " +
                            (tiempoPulsacionAnterior - getTiempo()) +
                            "\n"
            );

            tiempoPulsacionAnterior = getTiempo();
            return true;
        }
        else{
            tiempoPulsacionAnterior = getTiempo();
            return false;
        }
    }

    public void setPausaInicial(int pausaInicial) {
        this.pausaInicial = pausaInicial;
    }

}
