package com.entropy.david.Letras;

import android.content.Context;
import android.graphics.Color;
import android.util.Log;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.entropy.david.Letras.Caracter;
import com.entropy.david.Letras.TypeFaces;
import com.entropy.david.Medidas.Medidas;
import com.entropy.david.Movimientos.Movimiento;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;

//import sadf.myapplication7.app.Medidas.Medidas;
//import sadf.myapplication7.app.Movimientos.Movimiento;

/**
 * Created by david on 22/07/2014.
 */
public class InstanciadorDeLetras {             //Factory Method Patron

    static public final int LETRAS_LATINAS = 0;
    static public final int LETRAS_RUSAS = 1;
    static public final int LETRAS_CHINAS = 2;
    static public final int LETRAS_ARABES = 3;
    static public final int LETRAS_DEBANAGARI = 4;
    static public final int LETRAS_HEBREAS = 5;
    static public final int LETRAS_LATINAS_LASER = 6;
    static public final int LETRAS_LATINAS_GUSANO = 7;
    static public final int NUMEROS = 8;
    static public final int LETRAS_LATINAS_VIENTO_LATERAL = 9;
    static public final int LETRAS_LATINAS_BLOQUE_INFINITO = 10;

    private Context applicationContext;
    private RelativeLayout relativeLayout;
    private Medidas medidas;

    private Caracter[] letras;
    private ArrayList<Caracter> listaLetras;


    public InstanciadorDeLetras(Context applicationContext, RelativeLayout relativeLayout) {
        this.applicationContext = applicationContext;
        this.relativeLayout = relativeLayout;

        medidas = Medidas.getMedidas();
    }

    public Caracter[] getLetras() {
        listaLetras = new ArrayList<Caracter>();
        letras = iniciaLetras();
        return letras;
    }

    public Caracter[] getLetras(int tipo) {

        listaLetras = new ArrayList<Caracter>();

        switch (tipo){
            case LETRAS_LATINAS:                                                                    //latinas
                instanciaLetrasLatinas();                       break;
            case LETRAS_RUSAS:
                creaLetrasCirilicas( Color.rgb(77,178,250));    break;                              //cirilicas
            case LETRAS_CHINAS:
                creaLetrasChinas( Color.LTGRAY);                break;                              //chinas
            case LETRAS_ARABES:
                creaLetrasArabes( Color.rgb(219,219,4));        break;                              //arabes
            case LETRAS_DEBANAGARI:
                creaLetrasDevanagari( Color.rgb(250,181,62));   break;                              //devanagari
            case LETRAS_HEBREAS:
                creaLetrasHebreas( Color.RED);                  break;                              //hebreas

            case NUMEROS:
                instanciaNumeros(Color.rgb(43, 173, 69));       break;                              //hebreas

            case LETRAS_LATINAS_LASER:
                instanciaLetrasLaser();                         break;                              //laser
            case LETRAS_LATINAS_GUSANO:
                instanciaLetrasGusano();                        break;                              //gusano
            case LETRAS_LATINAS_BLOQUE_INFINITO:
                creaLetrasLatinasBloqueInfinito(Color.rgb(255,159,54));       break;                              //gusano

            case LETRAS_LATINAS_VIENTO_LATERAL:
                instanciaLetrasVientoLateral(Color.BLUE);       break;                              //gusano




            default:
                                                                break;
        }
        return letrasComoArray(listaLetras);
    }

    /**Encargado de llamar a la generacion de cada tipo de letra
     *
     */
    private Caracter[] iniciaLetras() {

//        creaLetrasChinas(Color.rgb(230,230,230) /*Color.LTGRAY*/);                                  //chinas
//        creaLetrasCirilicas( Color.rgb(77,178,250));                                                //cirilicas
//        creaLetrasArabes( Color.rgb(219,219,4));                                                    //arabes
//        creaLetrasDevanagari( Color.rgb(250,181,62));                                               //devanagari
//        creaLetrasHebreas(Color.rgb(255,178,102)/*Color.rgb(62, 62, 62)*/);                         //hebreo

        instanciaLetrasLatinas();                                                                   //latinas

//        instanciaNumeros(Color.rgb(255, 6, 67));


        return letrasComoArray(listaLetras);
    }

    private void instanciaNumeros(int color) {

        creaNumeros( '0', color, Movimiento.MOVIMIENTO_ESTATICO, medidas.POSICION_X_LETRAS_LATINAS_2, true, 0);

    }

    private void instanciaLetrasLatinas() {

        //matrix
        creaLetrasLatinas( 'a', Color.rgb(43, 173, 69), Movimiento.MOVIMIENTO_MATRIX, medidas.POSICION_X_LETRAS_LATINAS_1, false, 0);
        creaLetrasLatinas( 'A', Color.rgb(43, 173, 69), Movimiento.MOVIMIENTO_MATRIX, medidas.POSICION_X_LETRAS_LATINAS_6, true, 0);

        //viento lateral
        instanciaLetrasVientoLateral(Color.BLUE);
        instanciaLetrasVientoLateralMinusculas(Color.BLUE);

        //letras colores sin mezclar
        creaLetrasLatinas( 'A', Color.rgb(0,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_2, true, 0);
        creaLetrasLatinas( 'a', Color.rgb(0,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_4, true, TypeFaces.GLORIA_HALLELUJAH);

        creaLetrasLatinas( 'A', Color.rgb(255,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_3, true, 0);
        creaLetrasLatinas( 'a', Color.rgb(255,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_5, true, TypeFaces.O4B_03);


        //letras colores sin mezclar
        creaLetrasLatinas( 'A', Color.rgb(0,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_7, true, 0);
        creaLetrasLatinas( 'a', Color.rgb(0,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_9, true, TypeFaces.GLORIA_HALLELUJAH);

        creaLetrasLatinas( 'A', Color.rgb(255,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_8, true, 0);
        creaLetrasLatinas( 'a', Color.rgb(255,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_10, true, TypeFaces.O4B_03);


   }

    private void instanciaLetrasLaser(){
        creaLetras( 'a', 26, Color.rgb(252,147,17) /*Color.rgb(252,147,17) naranja*/, 0, 500, 10, 0, 40, TypeFaces.O4B_03);
    }

    private void instanciaLetrasGusano(){
        creaLetras( 'A', 26, Color.rgb(252,147,17), 0, 200, 10, 0, 40, TypeFaces.POR_DEFECTO);
    }

    private void instanciaLetrasVientoLateral(int c){
        creaLetras( 'A', 26, c, Movimiento.MOVIMIENTO_VIENTO_LATERAL, 50, 10, 0, 42, TypeFaces.POR_DEFECTO);
    }

    private void instanciaLetrasVientoLateralMinusculas(int c){
        creaLetras( 'a', 26, c, Movimiento.MOVIMIENTO_VIENTO_LATERAL, 350, 1080, 0, -42, TypeFaces.O4B_03);
    }

    private void creaLetrasHebreas(int rgb) {

        Caracter cr;

        final int PRIMERA_LETRA = 1488;
        final int NUMERO_DE_LETRAS = 27;// 0xFF;
        final int LETRAS_POR_FILA = 4;// 11; //en realidad son 12
        int x = -1;
        int y = -1;

        for(int i = 0; i< NUMERO_DE_LETRAS; i++){

            char valor = (char)(PRIMERA_LETRA+i);
            if (x < LETRAS_POR_FILA) x++;
            else x = 0;
            if(x == 0) y++;

            cr = new Caracter(valor, relativeLayout, applicationContext, rgb, 0f,
                    medidas.POSICION_X_LETRAS_HEBREAS + medidas.ADICION_X_LETRAS_HEBREAS * x,
                    medidas.POSICION_y_LETRAS_HEBREAS + medidas.ADICION_y_LETRAS_HEBREAS * y,
                    Movimiento.MOVIMIENTO_BLOQUE_INFINITO, 0);
            listaLetras.add(cr);
        }

    }

    private void creaLetrasLatinasBloqueInfinito(int rgb) {

        Caracter cr;

        final int PRIMERA_LETRA = 'A';
        final int NUMERO_DE_LETRAS = 26;// 0xFF;
        final int LETRAS_POR_FILA = 4;// 11; //en realidad son 12
        int x = -1;
        int y = -1;

        for(int i = 0; i< NUMERO_DE_LETRAS; i++){

            char valor = (char)(PRIMERA_LETRA+i);
            if (x < LETRAS_POR_FILA) x++;
            else x = 0;
            if(x == 0) y++;

            cr = new Caracter(valor, relativeLayout, applicationContext, rgb, 0f,
                    medidas.POSICION_X_LETRAS_HEBREAS + medidas.ADICION_X_LETRAS_HEBREAS * x,
                    medidas.POSICION_y_LETRAS_HEBREAS + medidas.ADICION_y_LETRAS_HEBREAS * y,
                    Movimiento.MOVIMIENTO_BLOQUE_INFINITO, 0);
            listaLetras.add(cr);
        }
    }

    private void creaLetrasLatinas(int primeraLetra, int rgb, int tipoMovimiento, int posicionX, boolean derecha, int tipoLetra) {

        final int numLetras = 26;
        int pasoY;
        int posicionY;


        if(derecha == true){
            posicionY = medidas.POSICION_Y_LETRAS_LATINAS;
            pasoY = medidas.ADICION_Y_LETRAS_LATINAS;
        }
        else{
            //el tamaño es 1050 por eso uso 1025
            // solo se puede ustilizar 950 para que sea compatible con el modo apaisado uso 925
            posicionY = medidas.POSICION_Y_FIN_LETRAS_LATINAS;;
            pasoY = -medidas.ADICION_Y_LETRAS_LATINAS;
        }

        TextView tv;
        Caracter cr;

        for(int i = 0; i< numLetras; i++){

            char valor = (char)(primeraLetra+i);
            cr = new Caracter(valor, relativeLayout, applicationContext, rgb, 0.0f,
                    posicionY + pasoY * i,
                    posicionX,
                    tipoMovimiento, tipoLetra);

            listaLetras.add(cr);
        }
    }

    private void creaLetrasLatinasMixtas(int primeraLetra, int rgb, int tipoMovimiento, int posicionX, boolean derecha, int tipoLetra,
                                         int primeraLetra2, int rgb2, int tipoMovimiento2, int posicionX2, boolean derecha2, int tipoLetra2) {

        final int numLetras = 26;
        int pasoY;
        int posicionY;


        if(derecha == true){
            posicionY = medidas.POSICION_Y_LETRAS_LATINAS;
            pasoY = medidas.ADICION_Y_LETRAS_LATINAS;
        }
        else{
            //el tamaño es 1050 por eso uso 1025
            // solo se puede ustilizar 950 para que sea compatible con el modo apaisado uso 925
            posicionY = medidas.POSICION_Y_FIN_LETRAS_LATINAS;;
            pasoY = -medidas.ADICION_Y_LETRAS_LATINAS;
        }

        Caracter cr;

        for(int i = 0; i< numLetras; i+=2){

            char valor = (char)(primeraLetra+i);
            cr = new Caracter(valor, relativeLayout, applicationContext, rgb, 0.0f,
                    posicionY + pasoY * i,
                    posicionX,
                    tipoMovimiento, tipoLetra);

            listaLetras.add(cr);

            char valor2 = (char)(primeraLetra2+i+1);
            cr = new Caracter(valor2, relativeLayout, applicationContext, rgb2, 0.0f,
                    posicionY + pasoY * (i+1),
                    posicionX,
                    tipoMovimiento2, tipoLetra2);

            listaLetras.add(cr);
        }

    }

    private void creaNumeros(int primeraLetra, int rgb, int tipoMovimiento, int posicionX, boolean derecha, int tipoLetra) {

            final int numLetras = 10;
            float pasoY;
            int posicionY;


            if(derecha == true){
                posicionY = medidas.POSICION_Y_LETRAS_LATINAS;
                pasoY = medidas.ADICION_Y_LETRAS_LATINAS*2.5f;
            }
            else{
                //el tamaño es 1050 por eso uso 1025
                // solo se puede ustilizar 950 para que sea compatible con el modo apaisado uso 925
                posicionY = medidas.POSICION_Y_FIN_LETRAS_LATINAS + 10;
                pasoY = -medidas.ADICION_Y_LETRAS_LATINAS*2.5f;
            }

            Caracter cr;

            for(int i = 0; i< numLetras; i++){

                char valor = (char)(primeraLetra+i);
                cr = new Caracter(valor, relativeLayout, applicationContext, rgb, 0f,
                        (float) posicionY + pasoY * i,
                        posicionX,
                        tipoMovimiento, tipoLetra);

                listaLetras.add(cr);
            }
        }

    private void creaLetras( int primeraLetra, int numLetras, int rgb, int tipoMovimiento,
                                              int posicionX, int posicionY, int pasoX, int pasoY, int tipoLetra) {

        Caracter cr;

        for(int i = 0; i< numLetras; i++){

            char valor = (char)(primeraLetra+i);
            cr = new Caracter(valor, relativeLayout, applicationContext, rgb, 0f, posicionX + pasoX * i, posicionY + pasoY * i, tipoMovimiento, tipoLetra);

            listaLetras.add(cr);
        }
    }


    private void creaLetrasChinas(int rgb) {

        //rango caracteres chinos: //rango 4E00-9FFF        son 20991 letras, demasiadas
        final int PRIMERA_LETRA = 0x4E00;
        final int NUMERO_DE_LETRAS = 0x9FFF-0x4E00;
        final int LETRAS_POR_FILA = 13; // 15;
        int x = -1;
        int y = -1;

        for(int i = 0; i< NUMERO_DE_LETRAS; i += 55){

            char valor = (char)(PRIMERA_LETRA+i);
            if (x < LETRAS_POR_FILA) x++;
            else x = 0;
            if(x == 0) y++;

            listaLetras.add(
                    new Caracter(valor, relativeLayout, applicationContext, rgb, 0f,
                            (medidas.POSICION_X_LETRAS_CHINAS + medidas.ADICION_X_LETRAS_CHINAS * x)/*(10+ 60 * x)*/,
                            (medidas.POSICION_y_LETRAS_CHINAS + medidas.ADICION_y_LETRAS_CHINAS * y)/*(0+ 60 * y)*/,
                            Movimiento.MOVIMIENTO_ESTATICO, 0)
            );

        }

    }


    private void creaLetrasDevanagari(int rgb) {

        //rango caracteres devanagari: 0x904-0x939
        final int PRIMERA_LETRA = 0x0904;
        final int NUMERO_DE_LETRAS = 0x939-0x904;
        final int LETRAS_POR_FILA = 10;//15;
        int x = -1;
        int y = -1;

        for(int i = 0; i< NUMERO_DE_LETRAS; i++){

            char valor = (char)(PRIMERA_LETRA+i);
            if (x < LETRAS_POR_FILA) x++;
            else x = 0;
            if(x == 0) y++;

            listaLetras.add(
                    new Caracter(valor, relativeLayout, applicationContext, rgb, 0f,
                            (medidas.POSICION_X_LETRAS_DEVANAGARI+ medidas.ADICION_X_LETRAS_DEVANAGARI * x),
                            (medidas.POSICION_y_LETRAS_DEVANAGARI+ medidas.ADICION_y_LETRAS_DEVANAGARI * y),
                            Movimiento.MOVIMIENTO_REBOTE_VERTICAL, 0)
            );
        }

    }


    private void creaLetrasArabes(int rgb) {

        //rangos a crear: 0x622-0x623, 0x628-0x63A, 0x641-0x64A

        int color = rgb;
        int LETRAS_POR_FILA = 3 -1; //en realidad son 4
        int x = 0;
        int y = 0;
        int i = 0;

        Caracter cr;

        //rangos a crear: 0x622-0x623
        int PRIMERA_LETRA = 0x0622;
        int NUMERO_DE_LETRAS = 0x0623- PRIMERA_LETRA;

        for(; i<= NUMERO_DE_LETRAS; i++){

            char valor = (char)(PRIMERA_LETRA+i);

            cr = getCaracterArabe(color, x, y, valor);
            listaLetras.add(cr);

            if (x < LETRAS_POR_FILA) x++;
            else x = 0;
            if(x == 0) y++;
        }

        //rangos a crear: 0x628-0x63A
        PRIMERA_LETRA = 0x0628;
        NUMERO_DE_LETRAS = 0x063B-PRIMERA_LETRA;

        for(i = 0; i< NUMERO_DE_LETRAS; i++){

            char valor = (char)(PRIMERA_LETRA+i);
            cr = getCaracterArabe(color, x, y, valor);
            listaLetras.add(cr);

            if (x < LETRAS_POR_FILA) x++;
            else x = 0;
            if(x == 0) y++;

        }

        //rangos a crear: 0x641-0x64A
        final int PRIMERA_LETRA2 = 0x0641;
        final int NUMERO_DE_LETRAS2 = 0x0658-PRIMERA_LETRA;

        for(i = 0; i< 10; i++){     //son solo 10 letras

            char valor = (char)(PRIMERA_LETRA2+i);
            cr = getCaracterArabe(color, x, y, valor);
            listaLetras.add(cr);

            if (x < LETRAS_POR_FILA) x++;
            else x = 0;
            if(x == 0) y++;

        }

        if (x < LETRAS_POR_FILA) x++;
        else x = 0;
        if(x == 0) y++;
        if (x < LETRAS_POR_FILA) x++;
        else x = 0;
        if(x == 0) y++;
        if (x < LETRAS_POR_FILA) x++;
        else x = 0;
        if(x == 0) y++;
        if (x < LETRAS_POR_FILA) x++;
        else x = 0;
        if(x == 0) y++;
        if (x < LETRAS_POR_FILA) x++;
        else x = 0;
        if(x == 0) y++;

        //rangos a crear: 0x641-0x64A
        final int PRIMERA_LETRA3 = 0x0660;
        final int NUMERO_DE_LETRAS3 = 0x066A-PRIMERA_LETRA3;

        for(i = 0; i< NUMERO_DE_LETRAS3; i++){     //son solo 10 letras

            char valor = (char)(PRIMERA_LETRA3+i);
            cr = getCaracterArabe(color, x, y, valor);
            listaLetras.add(cr);

            if (x < LETRAS_POR_FILA) x++;
            else x = 0;
            if(x == 0) y++;

        }

//
//        //rangos a crear: 0x641-0x64A
//        final int PRIMERA_LETRA2 = 0x0641;
//        final int NUMERO_DE_LETRAS2 = 0x0658-PRIMERA_LETRA;
//
//        for(i = 0; i< NUMERO_DE_LETRAS2; i++){
//
//            char valor = (char)(PRIMERA_LETRA2+i);
//            cr = getCaracterArabe(color, x, y, valor);
//            listaLetras.add(cr);
//
//            if (x < LETRAS_POR_FILA) x++;
//            else x = 0;
//            if(x == 0) y++;
//
//        }
    }

    private Caracter getCaracterArabe(int color, int x, int y, char valor) {
        Caracter cr;
        cr = new Caracter(valor, relativeLayout, applicationContext, color, 0f,
                medidas.POSICION_X_LETRAS_ARABES + medidas.ADICION_X_LETRAS_ARABES * x,
                medidas.POSICION_y_LETRAS_ARABES + medidas.ADICION_y_LETRAS_ARABES * y,
                Movimiento.MOVIMIENTO_BLOQUE_REBOTE_HORIZONTAL, 0);
        return cr;
    }

    private void creaLetrasCirilicas(int rgb) {

        Caracter cr;

        final int PRIMERA_LETRA = 1040;
        final int NUMERO_DE_LETRAS = 64;// 0xFF;
        final int LETRAS_POR_FILA = 10;// 11; //en realidad son 12
        int x = -1;
        int y = -1;

        for(int i = 0; i< NUMERO_DE_LETRAS; i++){

            char valor = (char)(PRIMERA_LETRA+i);
            if (x < LETRAS_POR_FILA) x++;
            else x = 0;
            if(x == 0) y++;

            cr = new Caracter(valor, relativeLayout, applicationContext, rgb, 0f,
                    medidas.POSICION_X_LETRAS_CIRILICAS + medidas.ADICION_X_LETRAS_CIRILICAS * x,
                    medidas.POSICION_y_LETRAS_CIRILICAS + medidas.ADICION_y_LETRAS_CIRILICAS * y,
                    Movimiento.MOVIMIENTO_BLOQUE_REBOTE_VERTICAL, 0);
            listaLetras.add(cr);
        }
    }

    private Caracter[] letrasComoArray(ArrayList<Caracter> listaLetras) {
        Caracter[] aux = new Caracter[listaLetras.size()];
        listaLetras.toArray(aux);
        return aux;
    }

    private void iniciaLetra(ArrayList<Caracter> letras, RelativeLayout relativeLayout) {           //codigo de depuracion con una letra

        final int LETRAS_1 = 1;

        TextView tv;
        Caracter cr;

        for(int i = 0; i< LETRAS_1; i++){

            char valor = (char)('A'+i);
            cr = new Caracter(valor, relativeLayout, applicationContext, Color.BLUE, 0f, i,100,
                    Movimiento.MOVIMIENTO_LINEA_RECTA, 0);

            Toast.makeText(applicationContext, cr.printInfo(), Toast.LENGTH_SHORT).show();
            letras.add(cr);
            Toast.makeText(applicationContext, cr.printInfo(), Toast.LENGTH_SHORT).show();
        }
    }

    private void pintaHora(int llamada) {
        DateFormat df = new SimpleDateFormat("HH:mm:ss.SSSZ");
        String date = df.format(Calendar.getInstance().getTime());
        Log.v("tiempo", "tiempo en instanciador: " + date.toString() + " llamada "+ llamada +"\n");
    }

}

//version 1.11
//
//        creaLetrasLatinas( 'A', Color.rgb(43, 173, 69), Movimiento.MOVIMIENTO_MATRIX, medidas.POSICION_X_LETRAS_LATINAS_2, true, 0);
//        creaLetrasLatinas('a', Color.rgb(43, 173, 69), Movimiento.MOVIMIENTO_MATRIX, medidas.POSICION_X_LETRAS_LATINAS_1, false, 0);                      //matrix minusculas verde oscuro
//
//        creaLetrasLatinas( 'A', Color.rgb(0,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_3, true, 0);        //mayusculas negras arriba
//        creaLetrasLatinas( 'a', Color.rgb(0,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_5, true, 0);       //minusculas negras medio-bajo
//
//        creaLetrasLatinas( 'A', Color.rgb(255,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_4, true, 0);     //mayusculas rojas medio
//        creaLetrasLatinas( 'a', Color.rgb(255,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_6, true, 0);      //minusculas rojas medio


//version 2.1
//
//        creaLetrasLatinas( 'A', Color.rgb(43, 173, 69), Movimiento.MOVIMIENTO_MATRIX, medidas.POSICION_X_LETRAS_LATINAS_2, true, 0);
//        creaLetrasLatinas('a', Color.rgb(5, 252, 55), Movimiento.MOVIMIENTO_MATRIX, medidas.POSICION_X_LETRAS_LATINAS_1, false, 0);                      //matrix minusculas verde oscuro
//
//        creaLetrasLatinas( 'A', Color.rgb(200,200,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_8, true, TypeFaces.O4B_20);
//        creaLetrasLatinas( 'A', Color.rgb(255,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_6, true, TypeFaces.GLORIA_HALLELUJAH);     //mayusculas rojas medio
//        creaLetrasLatinas( 'a', Color.rgb(0,128,255), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_7, false, TypeFaces.O4B_03);      //minusculas verde azulado medio-arriba
//        creaLetrasLatinas( 'A', Color.rgb(0,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_5, true, TypeFaces.JANVIER_LIGHT);        //mayusculas negras arriba



//colores mezclados
//        creaLetrasLatinasMixtas( 'A', Color.rgb(0,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_3, true, 0,
//                'a', Color.rgb(255,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_6, true, TypeFaces.O4B_03);        //mayusculas negras arriba
//
//        creaLetrasLatinasMixtas( 'a', Color.rgb(255,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_6, true, TypeFaces.O4B_03,
//                'A', Color.rgb(0,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_3, true, 0);        //mayusculas negras arriba
//
//        creaLetrasLatinasMixtas('A', Color.rgb(255,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_4, true, 0,
//                'a', Color.rgb(0,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_5, true, TypeFaces.GLORIA_HALLELUJAH );        //mayusculas negras arriba
//
//        creaLetrasLatinasMixtas('a', Color.rgb(0,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_5, true, TypeFaces.GLORIA_HALLELUJAH,
//                'A', Color.rgb(255,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_4, true, 0);        //mayusculas negras arriba



//        //colores iniciales
//        creaLetrasLatinas( 'a', Color.rgb(225,225,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_12, false, TypeFaces.O4B_20);       //minusculas negras medio-bajo
//        creaLetrasLatinas( 'a', Color.rgb(204, 0, 204), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_10, false, TypeFaces.O4B_03);      //minusculas rosas medio-bajo
////        creaLetrasLatinas('a', Color.rgb(43, 173, 69), Movimiento.MOVIMIENTO_MATRIX, medidas.POSICION_X_LETRAS_LATINAS_1, false);                      //matrix minusculas verde oscuro
////        creaLetrasLatinas( 'A', Color.rgb(5, 252, 55), Movimiento.MOVIMIENTO_MATRIX, medidas.POSICION_X_LETRAS_LATINAS_2, true);                      //matrix mayusculas verde claro
//        creaLetrasLatinas( 'A', Color.rgb(0,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_3, true, TypeFaces.JANVIER);        //mayusculas negras arriba
////        creaLetrasLatinas( 'A', Color.rgb(204, 0, 204), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_4, true);        //mayusculas rosas arriba
//        creaLetrasLatinas( 'A', Color.rgb(0,204,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_5, true,TypeFaces.COMICATE);       //mayusculas verde azulado medio-arriba
////        creaLetrasLatinas( 'A', Color.rgb(200,200,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_5, true);       //mayusculas verde azulado medio-arriba
//        creaLetrasLatinas( 'a', Color.rgb(255,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_6, true, TypeFaces.POR_DEFECTO);      //minusculas rojas medio
////        creaLetrasLatinas( 'A', Color.rgb(255,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_7, false);     //mayusculas rojas medio
//        creaLetrasLatinas( 'a', Color.rgb(0,128,255), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_8, false, TypeFaces.LE_FUTUR_ATENDRA);      //minusculas verde azulado medio-arriba
////        creaLetrasLatinas( 'a', Color.rgb(0,0,0), Movimiento.MOVIMIENTO_LINEA_RECTA_REBOTE, medidas.POSICION_X_LETRAS_LATINAS_9, false);       //minusculas negras medio-bajo
