package com.entropy.david.Manejadores;

import android.content.Context;
import android.widget.RelativeLayout;

import com.entropy.david.Letras.Caracter;
import com.entropy.david.Letras.InstanciadorDeLetras;

import java.util.ArrayList;

//import sadf.myapplication7.app.Medidas.Medidas;
//import sadf.myapplication7.app.Movimientos.Movimiento;

/**
 * Created by david on 22/07/2014.
 */
public class InstanciaManejadoresDeLetras {             //Factory Method Patron


    RelativeLayout relativeLayout;
    Context applicationContext;

    InstanciadorDeLetras i;

    Manejador[] manejadores;



    public InstanciaManejadoresDeLetras(Context applicationContext, RelativeLayout relativeLayout) {
        this.applicationContext = applicationContext;
        this.relativeLayout = relativeLayout;

        i = new InstanciadorDeLetras(applicationContext, relativeLayout);

    }

    public Manejador[] getManejadores() {

        Caracter[] letras;          //array auxiliar que contiene las letras
        ArrayList<Manejador> losManejadores = new ArrayList<>();

        letras = i.getLetras(InstanciadorDeLetras.LETRAS_LATINAS_LASER);
        losManejadores.add(new ManejadorLaser(letras));

        letras = i.getLetras(InstanciadorDeLetras.LETRAS_LATINAS_GUSANO);
        losManejadores.add(new ManejadorSerpiente(letras));

//        letras = i.getLetras(InstanciadorDeLetras.LETRAS_LATINAS_BLOQUE_INFINITO);
//        losManejadores.add(new ManejadorBloqueInfinito(letras));


        manejadores = new Manejador[losManejadores.size()];
        losManejadores.toArray(manejadores);

        return manejadores;
    }

}
