package com.entropy.david.Manejadores;

import android.annotation.TargetApi;
import android.os.Build;
import android.util.Log;

import com.entropy.david.Letras.Caracter;

import java.util.ArrayList;

import static java.lang.Math.PI;
import static java.lang.Math.abs;
import static java.lang.Math.atan2;
import static java.lang.Math.cos;
import static java.lang.Math.random;
import static java.lang.Math.signum;
import static java.lang.Math.sin;
import static java.lang.Math.sqrt;

/**
 * Created by david on 11/06/2014.
 */
@TargetApi(Build.VERSION_CODES.HONEYCOMB)
public class ManejadorSerpiente extends Manejador {

    private int tiempo = 0;

    //    private static final int VELOCIDAD_MAXIMA = 7; //anteriormente 6 //comodo en 3
    private static final float ANGULO_MAX_GIRO = 30;

    public ManejadorSerpiente(Caracter[] letras) {
        super(letras);
        inicializacionConcreta();
    }

    @Override
    public int getTipoManejador() {
        return MANEJADOR_GUSANO;
    }

    @Override
    protected void inicializacionConcreta() {
        inicializaVelocidades(VELOCIDAD_MAXIMA);
        inicializaPuntos();
    }

    @Override
    public void mueve() {
        for (int i = 0; i < letras.length - 1; i++) {

            int ir_a = (i * (PASOS + 1) + 1);

            letras[i].setX(puntos.get(ir_a).getX());
            letras[i].setY(puntos.get(ir_a).getY());

        }
        mueveUltimaLetra(letras[letras.length - 1]);
    }

    private void mueveUltimaLetra(Caracter letra) {

        if (tiempo % (57 * PASOS / 7) == 0) {
//        if(tiempo%57==0){
            reInicializaVelocidades(letra);
        } else {
        }

        movimiento_vertical(letra);
        movimiento_horizontal(letra);
        puntos.remove(0);
        puntos.add(new Punto(letra.getX(), letra.getY()));

        tiempo++;
    }

    private void reInicializaVelocidades(Caracter letra) {

        double anguloExtra = (random() * ANGULO_MAX_GIRO);    // (-30,+30)
        if (random() < 0.5d) anguloExtra = -anguloExtra;

        //datos actuales
        double anguloActual = atan2(b, a) * 180 / PI;   //paso el angulo a grados para trabajar
        double modulo_actual = sqrt(a * a + b * b);

        //angulo modificado
        double angulo = anguloActual + anguloExtra;
        angulo = angulo * PI / 180;                     //paso el angulo a radianes para utilizar


        Log.v("Angulo", "Angulo actual: " + anguloActual + " angulo extra: " + anguloExtra + " angulo final: " + angulo * 180 / PI);
//        Log.v("Angulo", "Valor a: "+ a+" valor b: "+ b);

        a = (float) (cos(angulo) * modulo_actual);
        b = (float) (sin(angulo) * modulo_actual);

//        Log.v("Angulo", "Valor a: "+ a+" valor b: "+ b);
//        Log.v("Angulo", "inicial cos: "+ cos(anguloActual)+ "sen: "+sin(anguloActual));
//        Log.v("Angulo", "final cos: "+ cos(angulo)+ "sen: "+sin(angulo));

    }


}