package com.entropy.david.Medidas;

/**Contiene las medidas de los diferentes modelos de telefono utilizados
 * Created by david on 03/09/2014.
 */
public abstract class Medidas {

    //dispositivo seleccionado
    static final public int DISPOSITIVO = 3;

    //dispositivos posibles
    static final public int NEXUS_5 = 1;
    static final public int G4 = 2;
    static final public int G4_Desarrollo = 3;

    //caracteristicas de la pantalla
    public static float TAMAÑO_MAX_PANTALLA_Y = 1500;//1400;
    public static float TAMAÑO_MAX_PANTALLA_X = 950;//1050; //900;
    public static float TAMAÑO_MIN_PANTALLA_Y = 0;// 100;
    public static float TAMAÑO_MIN_PANTALLA_X = 0;//50;
    public static float ANCHO_PANTALLA_X = TAMAÑO_MAX_PANTALLA_X - TAMAÑO_MIN_PANTALLA_X;
    public static float LARGO_PANTALLA_Y = TAMAÑO_MAX_PANTALLA_Y - TAMAÑO_MIN_PANTALLA_Y;

    //caracteristicas del desvio
    public static int DESVIO_Y_VERTICAL = 100;
    public static int DESVIO_X_VERTICAL = 15;
    public static int DESVIO_Y_HORIZONTAL = 100;
    public static int DESVIO_X_HORIZONTAL = 15;
    public static double DISTANCIA_DE_RANGO_MAXIMA = 100.0;
    public static double DISTANCIA_DE_RANGO_MAXIMA_MUY_CERCA = 10.0;


    //caracteristicas de disposicion de letras
    public static int POSICION_X_LETRAS_CHINAS = 10;
    public static int ADICION_X_LETRAS_CHINAS =70;
    public static int POSICION_y_LETRAS_CHINAS = 0;
    public static int ADICION_y_LETRAS_CHINAS =56;

    public static int POSICION_X_LETRAS_DEVANAGARI = 25;
    public static int ADICION_X_LETRAS_DEVANAGARI = 85;
    public static int POSICION_y_LETRAS_DEVANAGARI = 300;
    public static int ADICION_y_LETRAS_DEVANAGARI = 100;

    public static int POSICION_X_LETRAS_ARABES = 700;
    public static int ADICION_X_LETRAS_ARABES = 85;
    public static int POSICION_y_LETRAS_ARABES = 150;
    public static int ADICION_y_LETRAS_ARABES = 100;

    public static int POSICION_X_LETRAS_HEBREAS = 250;
    public static int ADICION_X_LETRAS_HEBREAS = 85;
    public static int POSICION_y_LETRAS_HEBREAS = 650;
    public static int ADICION_y_LETRAS_HEBREAS = 100;

    public static int POSICION_X_LETRAS_CIRILICAS = 57;
    public static int ADICION_X_LETRAS_CIRILICAS = 77;
    public static int POSICION_y_LETRAS_CIRILICAS = 150;
    public static int ADICION_y_LETRAS_CIRILICAS = 100;

    public static int POSICION_X_LETRAS_LATINAS_1 = 100;
    public static int POSICION_X_LETRAS_LATINAS_2 = 250;
    public static int POSICION_X_LETRAS_LATINAS_3 = 450;
    public static int POSICION_X_LETRAS_LATINAS_4 = 550;
    public static int POSICION_X_LETRAS_LATINAS_5 = 750;
    public static int POSICION_X_LETRAS_LATINAS_6 = 850;
    public static int POSICION_X_LETRAS_LATINAS_7 = 1000;
    public static int POSICION_X_LETRAS_LATINAS_8 = 1150;
    public static int POSICION_X_LETRAS_LATINAS_9 = 1300;
    public static int POSICION_X_LETRAS_LATINAS_10 = 1450;
    public static int POSICION_X_LETRAS_LATINAS_11 = 1450;
    public static int POSICION_X_LETRAS_LATINAS_12 = 1450;
    public static int POSICION_X_LETRAS_LATINAS_13 = 950;
    public static int POSICION_X_LETRAS_LATINAS_14 =1025;

    public static int POSICION_Y_LETRAS_LATINAS = 0;
    public static int POSICION_Y_FIN_LETRAS_LATINAS = 880;
    public static int ADICION_Y_LETRAS_LATINAS = 35;


    //resultado clave
    public static int POSICION_X_LETRAS_RESULTADO_CLAVE = 150;
    public static int ADICION_X_LETRAS_RESULTADO_CLAVE = 200;
    public static int POSICION_Y_LETRAS_RESULTADO_CLAVE = 75;
//    public static int ADICION_Y_LETRAS_RESULTADO_CLAVE = 50;
    public static float TAMAÑO_LETRAS_RESULTADO_CLAVE = 25f;

    //resultado posibilidades
    public static int POSICION_X_LETRAS_RESULTADO = POSICION_X_LETRAS_RESULTADO_CLAVE;
    public static int ADICION_X_LETRAS_RESULTADO = ADICION_X_LETRAS_RESULTADO_CLAVE;
    public static int POSICION_Y_LETRAS_RESULTADO = 150;
    public static int ADICION_Y_LETRAS_RESULTADO = 50;
    public static float TAMAÑO_LETRAS_RESULTADO = 15f;

    //resultado aciertos posibilidades
    public static int POSICION_X_LETRAS_RESULTADO_ACIERTO = 200;
    public static int ADICION_X_LETRAS_RESULTADO_ACIERTO = ADICION_X_LETRAS_RESULTADO_CLAVE;
    public static int POSICION_Y_LETRAS_RESULTADO_ACIERTO = 90;
    public static int ADICION_Y_LETRAS_RESULTADO_ACIERTO = ADICION_Y_LETRAS_RESULTADO;
    public static float TAMAÑO_LETRAS_RESULTADO_ACIERTO = TAMAÑO_LETRAS_RESULTADO_CLAVE;




    public static Medidas getMedidas() {

        switch (DISPOSITIVO){
//            case Medidas.NEXUS_5:
//                return new Medidas_Nexus_5();
//            case Medidas.G4:
//                return new Medidas_G4();
            case Medidas.G4_Desarrollo:
                return new Medidas_G4Desarrollo();
            default:
                return null;
        }
    }
}
