package com.entropy.david.Movimientos;

import com.entropy.david.Letras.Caracter;
import com.entropy.david.Medidas.Medidas;

/**
 * Created by david on 11/06/2014.
 */
public abstract class Movimiento {

    //propiedades de pantalla
    static float TAMAÑO_MAX_PANTALLA_Y = Medidas.TAMAÑO_MAX_PANTALLA_Y;//1400;
    static float TAMAÑO_MAX_PANTALLA_X = Medidas.TAMAÑO_MAX_PANTALLA_X;//1050; //900;
    static float TAMAÑO_MIN_PANTALLA_Y = Medidas.TAMAÑO_MIN_PANTALLA_Y;// 100;
    static float TAMAÑO_MIN_PANTALLA_X = Medidas.TAMAÑO_MIN_PANTALLA_X;//50;
    static float ANCHO_PANTALLA_X = TAMAÑO_MAX_PANTALLA_X - TAMAÑO_MIN_PANTALLA_X;
    static float LARGO_PANTALLA_Y = TAMAÑO_MAX_PANTALLA_Y - TAMAÑO_MIN_PANTALLA_Y;

    //propiedades de movimiento
    public static final int MOVIMIENTO_ESTATICO = 0;
    public static final int MOVIMIENTO_BLOQUE_REBOTE_HORIZONTAL = 1;
    public static final int MOVIMIENTO_BLOQUE_REBOTE_VERTICAL = 2;
    public static final int MOVIMIENTO_LINEA_RECTA = 3;
    public static final int MOVIMIENTO_MATRIX = 4;
    public static final int MOVIMIENTO_RARO_1 = 5;
    public static final int MOVIMIENTO_REBOTE_VERTICAL = 6;
    public static final int MOVIMIENTO_LINEA_RECTA_REBOTE = 7;
    public static final int MOVIMIENTO_BLOQUE_INFINITO = 8;
    public static final int MOVIMIENTO_VIENTO_LATERAL = 9;

    //objetos propios
    Caracter cr;
    float x, y;
    //float xInicial, yInicial;


    public static Movimiento getMovimiento(int tipoMovimiento) {

        switch (tipoMovimiento){
            case MOVIMIENTO_ESTATICO: return new MovimientoEstatico();
            case MOVIMIENTO_BLOQUE_REBOTE_HORIZONTAL: return new MovimientoBloqueReboteHorizontal();
            case MOVIMIENTO_BLOQUE_REBOTE_VERTICAL: return new MovimientoBloqueReboteVertical();
            case MOVIMIENTO_LINEA_RECTA: return new MovimientoLineaRectaInfinito();
            case MOVIMIENTO_MATRIX: return new MovimientoMatrix();
            //case MOVIMIENTO_RARO_1: return new MovimientoRaro1();
            case MOVIMIENTO_REBOTE_VERTICAL: return new MovimientoReboteVertical();
            case MOVIMIENTO_LINEA_RECTA_REBOTE: return new MovimientoLineaRectaRebote();
            case MOVIMIENTO_BLOQUE_INFINITO: return new MovimientoBloqueInfinito();
            case MOVIMIENTO_VIENTO_LATERAL: return new MovimientoVientoLateral();
            default: return new MovimientoEstatico();
        }

    }

    public Movimiento(){
//        inicializaPosicion();
    }

    private void inicializaPosicion() {
        x = cr.getX();
        y = cr.getY();
//        xInicial = x;
//        yInicial = y;

        inicializacionConcreta();
    }

    public abstract int getTipoMovimiento();

    protected abstract void inicializacionConcreta();

    public abstract void mueve();

    public String getInfo(){
        return "\nTamaño de pantalla x,y : "+
                TAMAÑO_MAX_PANTALLA_X+","+TAMAÑO_MAX_PANTALLA_Y;
    };

    public void setCaracter(Caracter caracter) {
        cr = caracter;
        inicializaPosicion();
    }

    public void actualiza(){
        cr.setX(x);
        cr.setY(y);
    };

//    public void reinicia() {
//        x = xInicial;
//        y = yInicial;
//    }

}
