package com.entropy.david.Movimientos;

import android.annotation.TargetApi;
import android.os.Build;

/**
 * Created by david on 11/06/2014.
 */
@TargetApi(Build.VERSION_CODES.HONEYCOMB)
public class MovimientoLineaRectaInfinito extends Movimiento {

    private float a;
    private float b;

    final float VELOCIDAD_MAXIMA = 6 /3.5f; //inicialmente 6

    @Override
    public int getTipoMovimiento() {
        return MOVIMIENTO_LINEA_RECTA;
    }

    @Override
    protected void inicializacionConcreta() {
        inicializaVelocidades();
    }

    public MovimientoLineaRectaInfinito() {
        super();

    }

    private void inicializaVelocidades() {

        a = (float) ((Math.random()* VELOCIDAD_MAXIMA) - VELOCIDAD_MAXIMA/2);
        b = (float) ((Math.random()* VELOCIDAD_MAXIMA) - VELOCIDAD_MAXIMA/2);

    }

    @Override
    public void mueve() {
        movimietoRandom();
    }


    @Override
    public String getInfo() {

        String s = super.getInfo();
        s+= "\nMovimiento en Linea Recta, ";
        s+= "\nvalores de avance a/b : "+ a+","+b;
        s+= "\nvelocidad máxima: "+ VELOCIDAD_MAXIMA;

        return s;
    }

    private void movimietoRandom() {

        movimiento_horizontal();
        movimiento_vertical();

    }


    private void movimiento_vertical() {
        if( TAMAÑO_MIN_PANTALLA_Y <= y && y <= TAMAÑO_MAX_PANTALLA_Y) y += a;
        else if( y < TAMAÑO_MIN_PANTALLA_Y ) y = TAMAÑO_MAX_PANTALLA_Y;
        else if(TAMAÑO_MAX_PANTALLA_Y < y) y = TAMAÑO_MIN_PANTALLA_Y;
        cr.setY(y);
    }

    private void movimiento_horizontal() {
        if( TAMAÑO_MIN_PANTALLA_X <= x && x <= TAMAÑO_MAX_PANTALLA_X) x += b;
        else if( x < TAMAÑO_MIN_PANTALLA_X ) x = TAMAÑO_MAX_PANTALLA_X;
        else if(TAMAÑO_MAX_PANTALLA_X < x) x = TAMAÑO_MIN_PANTALLA_X;
        cr.setX(x);
    }


}
