package com.entropy.david.Movimientos;

import android.annotation.TargetApi;
import android.os.Build;

/**
 * Created by david on 11/06/2014.
 */
@TargetApi(Build.VERSION_CODES.HONEYCOMB)
public class MovimientoLineaRectaRebote extends Movimiento {

    private float a;
    private float b;

    final float VELOCIDAD_MAXIMA = 3 /3.5f; //anteriormente 6 //comodo en 3

    @Override
    public int getTipoMovimiento() {
        return MOVIMIENTO_LINEA_RECTA_REBOTE;
    }

    @Override
    protected void inicializacionConcreta() {
        inicializaVelocidades();
        situaEnRango();
    }

    private void situaEnRango() {
        if(x < TAMAÑO_MIN_PANTALLA_X) x = TAMAÑO_MIN_PANTALLA_X;
        if(x > TAMAÑO_MAX_PANTALLA_X) x = TAMAÑO_MAX_PANTALLA_X;
        if(y < TAMAÑO_MIN_PANTALLA_Y) y = TAMAÑO_MIN_PANTALLA_Y;
        if(y > TAMAÑO_MAX_PANTALLA_Y) y = TAMAÑO_MAX_PANTALLA_Y;
    }

    public MovimientoLineaRectaRebote() {
        super();
    }

    private void inicializaVelocidades() {
        a = (float) ((Math.random()* VELOCIDAD_MAXIMA) - VELOCIDAD_MAXIMA/2);
        b = (float) ((Math.random()* VELOCIDAD_MAXIMA) - VELOCIDAD_MAXIMA/2);
    }

    @Override
    public void mueve() {
        movimietoRandom();
    }

    @Override
    public String getInfo() {
        String s = super.getInfo();
        s+= "\nMovimiento en Linea Recta, ";
        s+= "\nvalores de avance a/b : "+ a+","+b;
        s+= "\nvelocidad máxima: "+ VELOCIDAD_MAXIMA;
        return s;
    }

    private void movimietoRandom() {
        movimiento_horizontal();
        movimiento_vertical();
    }

    private void movimiento_vertical() {

        if( y < TAMAÑO_MIN_PANTALLA_Y  || TAMAÑO_MAX_PANTALLA_Y < y   ) {
            b = -b;
        }
        cr.setY(y+=b);
    }

    private void movimiento_horizontal() {

        if( x < TAMAÑO_MIN_PANTALLA_X || TAMAÑO_MAX_PANTALLA_X < x)
            a = -a;

        cr.setX(x+=a);
    }


}
