package com.entropy.david.Vistas;

import android.annotation.TargetApi;
import android.app.Activity;
import android.content.Context;
import android.content.res.Configuration;
import android.graphics.Color;
import android.graphics.Typeface;
import android.os.Build;
import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.entropy.david.AccesoDatos;
import com.entropy.david.BucleAsincrono;
import com.entropy.david.Letras.Caracter;
import com.entropy.david.Letras.Contador;
import com.entropy.david.Letras.InstanciadorDeLetras;
import com.entropy.david.Manejadores.InstanciaManejadoresDeLetras;
import com.entropy.david.Manejadores.Manejador;
import com.entropy.david.Medidas.Medidas;
import com.entropy.david.Letras.TypeFaces;
import com.entropy.david.entropy.R;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;

/**
 * Created by david on 31/08/2014.
 */
@TargetApi(Build.VERSION_CODES.HONEYCOMB)
public class CambiaContrasena extends Activity {

    private static final int TIPOS_DE_LETRA = 1;
    private static final int NUMERO_DE_LETRAS = 5;

    private RelativeLayout relativeLayout;
    private Caracter[] letras;
    private Manejador[] manejadores;
    private Contador contador;
    private TextView[] tv;
    private Button[] b = new Button[TIPOS_DE_LETRA];
    CheckBox checkBoxMoverEnContraseña;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        pintaHora(1);
        super.onCreate(savedInstanceState);
        setContentView(R.layout.password);

        fondoActivo = false;
        relativeLayout = (RelativeLayout) findViewById(R.id.lLayoutCambiaContrasena);
        tv = new TextView[NUMERO_DE_LETRAS];

        pintaHora(2);
        b = new Button[TIPOS_DE_LETRA];
        b[0] = (Button) findViewById(R.id.LLatinas);
//        b[1] = (Button) findViewById(R.id.LRusas);
//        b[2] = (Button) findViewById(R.id.LChinas);
//        b[2].setTextColor(Color.GRAY);              //esta desactivado
//        b[3] = (Button) findViewById(R.id.LArabes);
//        b[4] = (Button) findViewById(R.id.LDevanagari);
//        b[5] = (Button) findViewById(R.id.LHebreas);

        checkBoxMoverEnContraseña = (CheckBox) findViewById(R.id.moverEnContraseña);
        actualizaSeñal(getApplicationContext());

        letras = new Caracter[0];

        pintaHora(3);
        contador = AccesoDatos.getContrasena(getApplicationContext());
        actualizaTextViews(contador);
        contador = new Contador(NUMERO_DE_LETRAS);
        pintaHora(4);

        if(contador.size() == 0){
            Toast.makeText(getApplicationContext(), "Por favor, establezca una contraseña", Toast.LENGTH_LONG).show();
        }

    }

    BucleAsincrono bucleAsincrono;

    public void pulsado(View v) {

        InstanciadorDeLetras i = new InstanciadorDeLetras(this, relativeLayout);
        InstanciaManejadoresDeLetras im = new InstanciaManejadoresDeLetras(this, relativeLayout);

        letras = new Caracter[0];          //array que contiene las letras
        manejadores = null;

        if (R.id.LLatinas == v.getId()) {
            letras = i.getLetras(InstanciadorDeLetras.LETRAS_LATINAS);
            manejadores = im.getManejadores();
        }
//        if (R.id.LRusas == v.getId()) {
//            letras = i.getLetras(InstanciadorDeLetras.LETRAS_RUSAS);
//        }
//        if (R.id.LChinas == v.getId()) {
//            letras = i.getLetras(InstanciadorDeLetras.LETRAS_CHINAS);
//        }
//        if (R.id.LArabes == v.getId()) {
//            letras = i.getLetras(InstanciadorDeLetras.LETRAS_ARABES);
//        }
//        if (R.id.LDevanagari == v.getId()) {
//            letras = i.getLetras(InstanciadorDeLetras.LETRAS_DEBANAGARI);
//        }
//        if (R.id.LHebreas == v.getId()) {
//            letras = i.getLetras(InstanciadorDeLetras.LETRAS_HEBREAS);
//        }

        paraBucle();
        bucleAsincrono = new BucleAsincrono(letras, manejadores, getApplicationContext());

        if(AccesoDatos.isMoverEnContraseña(getApplicationContext())) {
            if(bucleAsincrono != null) {
                bucleAsincrono.setPausaInicial(500);
                bucleAsincrono.execute();
            }
        }

        actualizaOrientacion(getApplication().getResources().getConfiguration());  //inicializa la orientacion

        deshabilitaBotones();
    }

    private boolean fondoActivo;


    @Override
    protected void onPause() {
        super.onPause();
        paraBucle();
    }

    @Override
    public boolean onTouchEvent(MotionEvent event) {

        Log.v("Desarrollo", "pulsado en fondo");

        paraBucle();

        //para evitar las pulsaciones en el fondo de pantalla que cuelgan la interfaz utilizamos fondoActivo
        if(!fondoActivo) {
            return false;
        }
        else {

            if (!pulsacionValida()) return true;

            Caracter c = null;

            c = muestraLetrasSeleccionadas(event);

            if (c == null) {
                return true;
            }
            else if (contador.add(c)) {                           //si se puede añadir
                limpiaElementos();
                actualizaTextViews(contador);
                habilitaBotones();
            }
            if (contador.lleno()) {                          //ya se ha elegido la clave
                limpiaElementos();
                deshabilitaBotones();
                paraBucle();
                actualizaTextViews(contador);
                AccesoDatos.guardaContrasena(contador, getApplicationContext());                                                                           //necesario implementar
            }
            return true;
        }
    }

    private void actualizaTextViews(Contador contador) {

        for (int i = 0; i < contador.size(); i++) {
            generaEtiquetaDeSeleccionados(contador.get(i), i);
        }

    }


    private Caracter muestraLetrasSeleccionadas(MotionEvent event) {

        ArrayList<Caracter> seleccionadas = new ArrayList<>();
        //String s = "";

        if (letras != null) {

            //recoge las posibles
            for (int i = 0; i < letras.length; i++) {

                if (letras[i].estaCerca(event)) {
                    seleccionadas.add(letras[i]);
                    //s += letras[i].getValor();
                }
            }
            //recoge las posibles en manejadores
            if(manejadores != null) {
                for (int i = 0; i < manejadores.length; i++) {

                    if (manejadores[i] != null) {
                        ArrayList<Caracter> ac = manejadores[i].pulsacion(event);
                        seleccionadas.addAll(ac);
                        manejadores[i] = null;
                    }
                }
            }

            if(seleccionadas.size()<1) return null;

            letras = new Caracter[seleccionadas.size()];
            seleccionadas.toArray(letras);

            relativeLayout.removeAllViews();

            //si solo hay una seleccionada es la respuesta
            if (seleccionadas.size() == 1) {
                return seleccionadas.get(0);
            }
            // si hay varias seleccionadas se expanden
            else if (seleccionadas.size() > 1) {
                Log.d("numero de letras", letras.length + "");
//                paraBucle();
                recoloca(letras);
            }
        }
        return null;
    }

    private void paraBucle() {
        if(bucleAsincrono!= null){
            bucleAsincrono.cancel(true);
        }
    }

    private void recoloca(Caracter[] seleccionadas) {

        Log.d("numero de letras2", seleccionadas.length + "");

        Medidas medida = Medidas.getMedidas();
        double distancia = medida.DISTANCIA_DE_RANGO_MAXIMA/2-1;
        double xMaximo = medida.TAMAÑO_MAX_PANTALLA_X;
        double xMinimo = medida.TAMAÑO_MIN_PANTALLA_X + 150f;
        double yMaximo = medida.TAMAÑO_MAX_PANTALLA_Y;
        double yMinimo = medida.TAMAÑO_MIN_PANTALLA_Y + 150f;
        double margen = 100;


        Caracter c;


        float tamañoDeUsoX = (float) (xMaximo - xMinimo);
        int LETRAS_POR_FILA = (int) (tamañoDeUsoX/ (margen+6d));
        int x = -1;
        int y = -1;

        for (int i = 0; i < seleccionadas.length; i++) {

            if (x < LETRAS_POR_FILA) x++;
            else x = 0;
            if(x == 0) y++;

            c = seleccionadas[i];

            c.setX((float) ((x * margen) % tamañoDeUsoX) + (float) xMinimo);
            c.setY((float) (y * margen + yMinimo));

            Log.d("Letra en posicion: ", c.getValor()+ " "+ c.getX()+ " "+ c.getY());

            c.verEn(relativeLayout);

        }

    }

    private void generaEtiquetaDeSeleccionados(Caracter c, int x) {
        tv[x] = new TextView(getApplicationContext());
        tv[x].setX(200 + (x * 60));
        tv[x].setY(750);
        tv[x].setText(c.getValor() + "");
        tv[x].setTextSize(25f);
        tv[x].setTextColor(c.getColor());
        tv[x].setTypeface(TypeFaces.getTipeFace(getApplicationContext(), c.getTipoLetra()), Typeface.BOLD);
        relativeLayout.addView(tv[x]);
    }

    private void ocultaContador() {

        for (int i = 0; i < NUMERO_DE_LETRAS; i++) {
            relativeLayout.removeView(tv[i]);
        }

    }

    private void deshabilitaBotones() {

        for (int i = 0; i < TIPOS_DE_LETRA; i++) {
            relativeLayout.removeView(b[i]);
        }
        ocultaContador();
        activaPulsacionesFondo(true);
    }

    private void activaPulsacionesFondo(boolean apf) {
        fondoActivo = apf;
    }


    private void habilitaBotones() {

        for (int i = 0; i < TIPOS_DE_LETRA; i++) {
            relativeLayout.addView(b[i]);
        }
        activaPulsacionesFondo(false);

        relativeLayout.addView(checkBoxMoverEnContraseña);

    }

    private void limpiaElementos() {
        letras = null;
        manejadores = null;
        relativeLayout.removeAllViews();
    }

    /**
     * salta al girar la pantalla (entre otros)
     */
    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        actualizaOrientacion(newConfig);
    }

    private void actualizaOrientacion(Configuration newConfig) {

        boolean isOrientacionVertical;// = Caracter.ORIENTACION_VERTICAL;

        if (newConfig.orientation == newConfig.ORIENTATION_PORTRAIT) {            //esta de pie
            isOrientacionVertical = true;
        } else {                                                                   //esta tumbado
            isOrientacionVertical = false;
        }

        Caracter.setIsOrientacionVertical(isOrientacionVertical);
        actualizaCaracteres();
    }

    /**
     * Actualiza la pantalla al cambiarla a apaisado
     */
    private void actualizaCaracteres() {
        if (letras != null) {
            for (int i = 0; i < letras.length; i++) {
                letras[i].actualiza();
            }
        }
    }

    private void iniciaElementos() {
        relativeLayout.setPadding(0, 0, 0, 0);
        actualizaOrientacion(getApplication().getResources().getConfiguration());  //inicializa la orientacion
    }

    private void pintaHora(int llamada) {
        DateFormat df = new SimpleDateFormat("HH:mm:ss.SSSZ");
        String date = df.format(Calendar.getInstance().getTime());
        Log.v("tiempo", "tiempo en setContrasena: " + date.toString() + " llamada " + llamada + "\n");
    }


    private long tiempoPulsacionAnterior;

    public boolean pulsacionValida() {

        //espera entre pulsaciones
        if (tiempoPulsacionAnterior + 150 < getTiempo()) {

            tiempoPulsacionAnterior = getTiempo();
            return true;
        }
        else{
            tiempoPulsacionAnterior = getTiempo();
            return false;
        }
    }

    public long getTiempo() {
        return System.currentTimeMillis();
    }

    public void notificaMover(View view){

//        CheckBox checkBoxMoverEnContraseña = (CheckBox) findViewById(R.id.moverEnContraseña);

        if(checkBoxMoverEnContraseña.isChecked()){
            AccesoDatos.señalaMoverContrasña(getApplicationContext());

            bucleAsincrono = new BucleAsincrono(letras, manejadores, getApplicationContext());
            if(AccesoDatos.isMoverEnContraseña(getApplicationContext())) {
                if(bucleAsincrono != null) {
                    bucleAsincrono.setPausaInicial(500);
                    bucleAsincrono.execute();
                }
            }
        }else{
            AccesoDatos.desseñalaMoverContrasña(getApplicationContext());
            if(bucleAsincrono != null) {
                bucleAsincrono.cancel(true);
            }
        }



        Log.v("Desarrollo", "metodo pulsaSeñalar entra, valor del checkbox = " + checkBoxMoverEnContraseña.isChecked());
    }

    private void actualizaSeñal(Context applicationContext) {

        if(AccesoDatos.isMoverEnContraseña(applicationContext)){
            checkBoxMoverEnContraseña.setChecked(true);
        }
        else{
            checkBoxMoverEnContraseña.setChecked(false);
        }

    }
}
