package com.entropy.david.Vistas;

import android.annotation.TargetApi;
import android.app.Activity;
import android.content.Intent;
import android.content.res.Configuration;
import android.graphics.Color;
import android.graphics.Point;
import android.os.Build;
import android.os.Bundle;
import android.util.Log;
import android.view.Display;
import android.view.MotionEvent;
import android.view.WindowManager;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.entropy.david.AccesoDatos;
import com.entropy.david.BucleAsincrono;
import com.entropy.david.Letras.Caracter;
import com.entropy.david.Letras.Contador;
import com.entropy.david.Manejadores.InstanciaManejadoresDeLetras;
import com.entropy.david.Letras.InstanciadorDeLetras;
import com.entropy.david.Manejadores.Manejador;
import com.entropy.david.entropy.R;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;


@TargetApi(Build.VERSION_CODES.HONEYCOMB)
public class Entrophy extends Activity {

    private RelativeLayout relativeLayout;
    private static BucleAsincrono bucleAsincrono;

    private static TextView textView1;                      //textView que muestra las pulsaciones hechas
    private Caracter[] letras = new Caracter[0];            //array que contiene las letras
    private Manejador[] manejadores;                        //array que contiene los manejadores
    private Contador contrasena;

    private int numPulsacion;
    private boolean primeraPulsacion = true;
    private ArrayList<Caracter>[] haSidoPulsado;

    private long tiempoInicio, tiempoFin;                   //para calcular el tiempo tardado


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
//        getIntent().setFlags(Intent.FLAG_ACTIVITY_NO_HISTORY);
        setContentView(R.layout.activity_main);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        RelativeLayout rl = (RelativeLayout) findViewById(R.id.rLayout);
        rl.setBackgroundColor(Color.LTGRAY);

        numPulsacion = 0;
    }

    @Override
    protected void onResume() {
        super.onResume();
        iniciaElementos();
        inicializaBucleAsincrono();
    }

    @Override
    protected void onPause() {
//        pintaHora(8);
        super.onPause();
        detenMovimiento();
        limpiaElementos();
//        pintaHora(9);
    }

    private void detenMovimiento() {
        bucleAsincrono.cancel(false);
    }

    /**
     * salta al girar la pantalla (entre otros)
     */
    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);

        actualizaOrientacion(newConfig);
    }

    /**
     * salta al pulsar la pantala
     */
    @Override
    public boolean onTouchEvent(MotionEvent event) {
        pulsacion(event);
        return true;
    }


    private void pulsacion(MotionEvent event) {

        //la primera pulsacion inicia el bucle
        if (primeraPulsacion) {
            primeraPulsacion = false;


            //reinicia pulsadas
            AccesoDatos.reseteaSharedPref(contrasena.size(), getApplicationContext());

            //si no hay contraseña se pide
            if (contrasena.size() == 0) {
                Intent iEnt;
                iEnt = new Intent(getApplicationContext(), CambiaContrasena.class);
                iEnt.setFlags(Intent.FLAG_ACTIVITY_NO_HISTORY);
                startActivity(iEnt);
            }
            //si hay contraseña continúa
            else {
                haSidoPulsado = new ArrayList[contrasena.size()];
            }

            //inicia movimiento
            tiempoInicio = System.currentTimeMillis();
            bucleAsincrono.execute();
        }

        //el resto de pulsaciones son clicks
        //solo si no es el mismo click repetido
        else if (bucleAsincrono.pulsacionValida()) {

            actualizaContadorPulsaciones(numPulsacion + 1);

            haSidoPulsado[numPulsacion] = new ArrayList<Caracter>();

            Log.v("Desarrollo", "Señalar= " + AccesoDatos.isSeñalar(getApplicationContext()));

            if (AccesoDatos.isSeñalar(getApplicationContext())) {
                //señala letras
                if (letras != null) {
                    for (int i = 0; i < letras.length; i++) {

                        if (letras[i].estaCerca(event)) {
                            letras[i].pulsada();

                            haSidoPulsado[numPulsacion].add(letras[i]);

                        } else letras[i].noPulsada();
                    }
                }
                //señala letras en manejador
                if (manejadores != null) {
                    for (int i = 0; i < manejadores.length; i++) {
                        manejadores[i].pulsaSeñalando(event, numPulsacion, haSidoPulsado);
                    }
                }
            } else {
                //añade letras pulsadas
                for (int i = 0; i < letras.length; i++) {

                    if (letras[i].estaCerca(event)) {
                        haSidoPulsado[numPulsacion].add(letras[i]);
                    }
                }
                //añade letras pulsadas en manejador
                if (manejadores != null) {
                    for (int i = 0; i < manejadores.length; i++) {
                        manejadores[i].pulsacion(event, numPulsacion, haSidoPulsado);
                    }
                }

            }

            //almacena pulsados y lanza "Resultado.class"
            numPulsacion++;
            if (numPulsacion > contrasena.size() - 1) {
                tiempoFin = System.currentTimeMillis();
                Log.v("Fin", "Asesinado por Fin" + " numPulsacion " + (numPulsacion + 1) + " tamaño contraseña " + (contrasena.size() - 1));
                fin();
                AccesoDatos.guardaPosibilidades(haSidoPulsado, getApplicationContext());
                AccesoDatos.guardaTiempo(tiempoFin - tiempoInicio, getApplicationContext());

                Intent i = new Intent(getApplicationContext(), Resultado.class);
                startActivity(i);
            }

        }
    }

    private void actualizaContadorPulsaciones(int numPulsacion) {
        String pulsaciones = "";
        for (int i = 0; i < numPulsacion; i++) {
            pulsaciones += " *";
        }
        textView1.setText(pulsaciones);
    }

    private void fin() {
        detenMovimiento();
    }

    private void iniciaElementos() {

        relativeLayout = (RelativeLayout) findViewById(R.id.rLayout);
        relativeLayout.setPadding(0, 0, 0, 0);
//        relativeLayout.                                                                //marcar el borde del area que se esta usando

        //usando un instanciador de letras
        InstanciadorDeLetras iLetras = new InstanciadorDeLetras(getApplicationContext(), relativeLayout);
        letras = iLetras.getLetras();

        //usando los manejadores
        InstanciaManejadoresDeLetras instanciaManejadoresDeLetras = new InstanciaManejadoresDeLetras(getApplicationContext(), relativeLayout);
        manejadores = instanciaManejadoresDeLetras.getManejadores();

        actualizaOrientacion(getApplication().getResources().getConfiguration());  //inicializa la orientacion

        contrasena = AccesoDatos.getContrasena(getApplicationContext());

        generaEtiquetaDeSeleccionados();

    }

    private void generaEtiquetaDeSeleccionados() {

        textView1 = new TextView(getApplicationContext());
        textView1.setTextColor(Color.GRAY);
        textView1.setX(10);
        textView1.setY(20);
//        textView1.setText("A!1");
        textView1.setTextSize(40);
        relativeLayout.addView(textView1);

    }

    /**
     * Actualiza la pantalla al cambiarla a apaisado
     */
    private void actualizaCaracteres() {

        for (int i = 0; i < letras.length; i++) {
            letras[i].actualiza();
        }
    }

    private void actualizaManejadores() {
        for (int i = 0; i < manejadores.length; i++) {
            manejadores[i].actualiza();
        }
    }

    private void limpiaElementos() {
        letras = new Caracter[0];
        relativeLayout.removeAllViews();
    }

    /**
     * Inicia el movimiento de las letras
     */
    private void inicializaBucleAsincrono() {
        bucleAsincrono = null;
        bucleAsincrono = new BucleAsincrono(this.letras, this.manejadores, getApplicationContext());
    }


    private void actualizaOrientacion(Configuration newConfig) {
        boolean isOrientacionVertical;// = Caracter.ORIENTACION_VERTICAL;

        if (newConfig.orientation == newConfig.ORIENTATION_PORTRAIT) {            //esta de pie
            isOrientacionVertical = true;
        } else {                                                                   //esta tumbado
            isOrientacionVertical = false;
        }

        Caracter.setIsOrientacionVertical(isOrientacionVertical);
        actualizaCaracteres();
        actualizaManejadores();
    }

    @TargetApi(Build.VERSION_CODES.HONEYCOMB_MR2)
    private void tamañoPantalla() {
        Display display = getWindowManager().getDefaultDisplay();
        Point size = new Point();
        display.getSize(size);
        int width = size.x;
        int height = size.y;

        Toast.makeText(this, "Dimensiones de la pantalla: x=" + width + " y= " + height, Toast.LENGTH_LONG).show();
    }

    private void deshacerMovimiento() {

        if (numPulsacion == 0) {
            finish();
        } else numPulsacion--;

        actualizaContadorPulsaciones(numPulsacion);
    }


    //no borrar
//    @Override
//    public boolean onKeyDown(int keyCode, KeyEvent event) {
//        //para dar un movimiento atras
//        if (keyCode == KeyEvent.KEYCODE_BACK) {
//
//            deshacerMovimiento();
//            for(int i = 0; i< letras.length; i++) {
//                letras[i].noPulsada();
//            }
//            // Si el listener devuelve true, significa que el evento esta procesado, y nadie debe hacer nada mas
//            return true;
//        }
//        //para las demas cosas, se reenvia el evento al listener habitual
//        return super.onKeyDown(keyCode, event);
//    }

//    private void pintaHora(int llamada) {
//        DateFormat df = new SimpleDateFormat("HH:mm:ss.SSSZ");
//        String date = df.format(Calendar.getInstance().getTime());
//        Log.v("tiempo", "tiempo en entrophy: " + date.toString() + " llamada " + llamada + "\n");
//    }

//    /**
//     * Muestra las letras seleccionadas en el textview de arriba
//     */
//    private String muestraLetrasSeleccionadas(MotionEvent event) {
//
//        if (bucleAsincrono.pulsacionValida()) {                           //solo si no es el mismo click repetido
////            pulsadas = "";
//
//            for (int i = 0; i < letras.length; i++) {
//
//                if (letras[i].estaCerca(event)) {
//                    letras[i].pulsada();
////                    pulsadas += " " + letras[i].getValor();
//                } else {
//                    letras[i].noPulsada();
//                }
//            }
////            pulsadas = estadistica( event, pulsadas, bucleAsincrono.getTiempo());         //metodo que mide la viabilidad del proyecto
//        }
//        return null;
//    }

}