package com.entropy.david.Vistas;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.View;
import android.widget.CheckBox;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;

import com.entropy.david.AccesoDatos;
import com.entropy.david.Vistas.CambiaContrasena;
import com.entropy.david.Vistas.Entrophy;
import com.entropy.david.Vistas.Resultado;
import com.entropy.david.entropy.R;


/**
 * Created by david on 31/08/2014.
 */
public class Lanzador extends ActionBarActivity {

    private Intent iEnt;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.launcher);
        actualizaSeñal(getApplicationContext());
        iniciaSeekBar();
        iniciaEtiquetas();

        iEnt = new Intent(getApplicationContext(), Entrophy.class);
        iEnt.setFlags(Intent.FLAG_ACTIVITY_NO_HISTORY);
        startActivity(iEnt);
    }

    private void iniciaEtiquetas() {

    }

    private void iniciaSeekBar() {
        SeekBar sb = (SeekBar) findViewById(R.id.seekBar);

        sb.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {

                int velocidad = seekBar.getProgress();

                actualizaEtiquetaVelocidad(velocidad);

                Log.v("Velocidad", "Velocidad: "+velocidad);
                AccesoDatos.setVelocidad(getApplicationContext(), velocidad);
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });

        sb.setProgress(AccesoDatos.getVelocidad(getApplicationContext()));
    }

    private void actualizaEtiquetaVelocidad(int velocidad) {
        TextView tv = (TextView) findViewById(R.id.etiquetaVelocidad);
        tv.setText(""+velocidad);
    }

    private void actualizaSeñal(Context applicationContext) {
        CheckBox checkBoxSeñal = (CheckBox) findViewById(R.id.señal);
        if(AccesoDatos.isSeñalar(applicationContext)){
            checkBoxSeñal.setChecked(true);
        }
        else{
            checkBoxSeñal.setChecked(false);
        }

    }

    public void pulsado(View v){

        if(R.id.Entrophy == v.getId()){
            iEnt.setFlags(Intent.FLAG_ACTIVITY_NO_HISTORY);
            startActivity(iEnt);
        }
        if(R.id.SetPassword == v.getId()){
            Intent i = new Intent(getApplicationContext(), CambiaContrasena.class);
            startActivity(i);
        }
        if(R.id.Result == v.getId()){
            Intent i = new Intent(getApplicationContext(), Resultado.class);
            startActivity(i);
        }

    }

    public void pulsaSeñalar(View v){

        CheckBox señalar = (CheckBox) v;

        if(señalar.isChecked()){
            AccesoDatos.señalizar(getApplicationContext());
        }else{
            AccesoDatos.desSeñalizar(getApplicationContext());
        }

        Log.v("Desarrollo", "metodo pulsaSeñalar entra, valor del checkbox = " +señalar.isChecked());

    }


}
