package com.entropy.david.Vistas;

import android.annotation.TargetApi;
import android.app.Activity;
import android.graphics.Color;
import android.graphics.Typeface;
import android.os.Build;
import android.os.Bundle;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.entropy.david.AccesoDatos;
import com.entropy.david.Letras.Caracter;
import com.entropy.david.Letras.Contador;
import com.entropy.david.Medidas.Medidas;
import com.entropy.david.Letras.TypeFaces;
import com.entropy.david.entropy.R;


/**
 * Created by david on 02/09/2014.
 */
@TargetApi(Build.VERSION_CODES.HONEYCOMB)
public class Resultado extends Activity {

    private Contador contraseña;
    private Caracter[][] posibilidades;
    private Medidas medidas;
    private long tiempo;
    private int aciertos;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.resultado);

        medidas = Medidas.getMedidas();
        aciertos = 0;
        //extrae informacion
        contraseña = AccesoDatos.getContrasena(getApplicationContext());
        posibilidades = AccesoDatos.getPosibilidades(getApplicationContext());
        tiempo = AccesoDatos.getTiempo(getApplicationContext());

        actualizaTextViews(contraseña, posibilidades, tiempo);
        boolean acertado = acertado();
        escribeTiempo(acertado, tiempo);
    }

    private RelativeLayout relativeLayout;
    private TextView[] tvClave;         //contraseña
    private TextView[][] tvPulsados;    //pulsados
    private TextView[] tvNumero;        //super índice
    private TextView[] tvAcierto;       //acertados
    private TextView tvTiempo;       //acertados
    private TextView tvContraseñaAcertada; //contraseña acertada

    private void actualizaTextViews(Contador contador, Caracter[][] posibilidades, long tiempo) {

        relativeLayout = (RelativeLayout) findViewById(R.id.resRelativeLayout);

        //contraseña
        if (contraseña != null) {
            tvClave = new TextView[contador.size()];
            for (int i = 0; i < contador.size(); i++) {
                escribeClave(contador.get(i), i);
            }
        }

        //pulsadas
        if (posibilidades != null) {
            tvPulsados = new TextView[posibilidades.length][];
            tvAcierto = new TextView[posibilidades.length];

            for (int i = 0; i < posibilidades.length; i++) {

                if (posibilidades[i] != null) {
                    tvPulsados[i] = new TextView[posibilidades[i].length];

                    for (int j = 0; j < posibilidades[i].length; j++) {

                        if (posibilidades[i][j] != null) {
                            if (posibilidades[i][j].igual(contraseña.get(i))) {
                                escribeAcierto(posibilidades[i][j], i, j);
                                señalizaAcierto(i);
                                aciertos++;
                            }
                            escribePulsado(posibilidades[i][j], i, j);
                        }
                    }
                }
            }
        }

        if (posibilidades != null) {
            for (int posicion = 0; posicion < posibilidades.length; posicion++) {
                tvNumero = new TextView[posibilidades.length];

                if (posibilidades[posicion] != null && posibilidades[posicion].length > 0) {
                    escribeNumero(posibilidades[posicion].length, posicion);
                }
            }
        }
    }

    private boolean acertado() {

        boolean acertado = false;

//        tvContraseñaAcertada = new TextView(getApplicationContext());
//        tvContraseñaAcertada.setX(medidas.POSICION_X_LETRAS_RESULTADO_CLAVE - 80);
//        tvContraseñaAcertada.setY(medidas.POSICION_Y_LETRAS_RESULTADO_CLAVE - 30);
//        tvContraseñaAcertada.setTextSize(medidas.TAMAÑO_LETRAS_RESULTADO_CLAVE * 0.57f);
//        tvContraseñaAcertada.setTypeface(null, Typeface.BOLD);

        if(aciertos == contraseña.size()){
//            tvContraseñaAcertada.setText("correcto");
//            tvContraseñaAcertada.setTextColor(Color.rgb(0,153,0));
            acertado = true;
        }
        else{
//            tvContraseñaAcertada.setText("FALLO");
//            tvContraseñaAcertada.setTextColor(Color.rgb(235,0,0));
            acertado = false;
        }

//        relativeLayout.addView(tvContraseñaAcertada);

        return acertado;
    }

    private void escribeTiempo(boolean acertado, long tiempo) {
        tvTiempo = new TextView(getApplicationContext());
        tvTiempo.setX(medidas.POSICION_X_LETRAS_RESULTADO_CLAVE);
        tvTiempo.setY(medidas.POSICION_Y_LETRAS_RESULTADO_CLAVE - 60);

        if(acertado) {
            tvTiempo.setText("Contraseña correcta (" + (((float) tiempo) / 1000) + " s)");
            tvTiempo.setTextSize(medidas.TAMAÑO_LETRAS_RESULTADO_CLAVE * 0.75f);
            tvTiempo.setTextColor(Color.rgb(43, 173, 69)/*verde*/);
        }
        else{
            tvTiempo.setText("Contraseña incorrecta (" + (((float) tiempo) / 1000) + " s)");
            tvTiempo.setTextSize(medidas.TAMAÑO_LETRAS_RESULTADO_CLAVE * 0.75f);
            tvTiempo.setTextColor(Color.RED);
        }


        relativeLayout.addView(tvTiempo);
    }

    private void escribeClave(Caracter c, int x) {
        tvClave[x] = new TextView(getApplicationContext());
        tvClave[x].setX(medidas.POSICION_X_LETRAS_RESULTADO_CLAVE + x * medidas.ADICION_X_LETRAS_RESULTADO_CLAVE);
        tvClave[x].setY(medidas.POSICION_Y_LETRAS_RESULTADO_CLAVE);
        tvClave[x].setText(c.getValor() + "");
        tvClave[x].setTextSize(medidas.TAMAÑO_LETRAS_RESULTADO_CLAVE);
        tvClave[x].setTextColor(c.getColor());
        tvClave[x].setTypeface(TypeFaces.getTipeFace(getApplicationContext(), c.getTipoLetra()), Typeface.BOLD);
        relativeLayout.addView(tvClave[x]);
    }

    private void escribePulsado(Caracter c, int x, int y) {
        tvPulsados[x][y] = new TextView(getApplicationContext());

        tvPulsados[x][y].setX(medidas.POSICION_X_LETRAS_RESULTADO + x * medidas.ADICION_X_LETRAS_RESULTADO);
        tvPulsados[x][y].setY(medidas.POSICION_Y_LETRAS_RESULTADO + y * medidas.ADICION_Y_LETRAS_RESULTADO);
        tvPulsados[x][y].setText(c.getValor() + "");
        tvPulsados[x][y].setTextSize(medidas.TAMAÑO_LETRAS_RESULTADO);
        tvPulsados[x][y].setTextColor(c.getColor());
        tvPulsados[x][y].setTypeface(TypeFaces.getTipeFace(getApplicationContext(), c.getTipoLetra()), Typeface.BOLD);
        relativeLayout.addView(tvPulsados[x][y]);
    }

    private void escribeAcierto(Caracter c, int x, int y) {
        tvPulsados[x][y] = new TextView(getApplicationContext());

        tvPulsados[x][y].setX(medidas.POSICION_X_LETRAS_RESULTADO_ACIERTO + medidas.ADICION_X_LETRAS_RESULTADO_ACIERTO * x);
        tvPulsados[x][y].setY(medidas.POSICION_Y_LETRAS_RESULTADO_ACIERTO + medidas.ADICION_Y_LETRAS_RESULTADO_ACIERTO * y);
        tvPulsados[x][y].setText(c.getValor() + "");
        tvPulsados[x][y].setTextSize(medidas.TAMAÑO_LETRAS_RESULTADO_ACIERTO);
        tvPulsados[x][y].setTextColor(c.getColor());
        tvPulsados[x][y].setTypeface(TypeFaces.getTipeFace(getApplicationContext(), c.getTipoLetra()), Typeface.BOLD);
        relativeLayout.addView(tvPulsados[x][y]);
    }

    private void escribeNumero(int cuantos, int x) {
        tvNumero[x] = new TextView(getApplicationContext());
        tvNumero[x].setX(medidas.POSICION_X_LETRAS_RESULTADO_CLAVE
                + medidas.TAMAÑO_LETRAS_RESULTADO_CLAVE
                + x * medidas.ADICION_X_LETRAS_RESULTADO_CLAVE);
        tvNumero[x].setY(medidas.POSICION_Y_LETRAS_RESULTADO_CLAVE);
        tvNumero[x].setText("  " + cuantos + "");
        tvNumero[x].setTextSize(medidas.TAMAÑO_LETRAS_RESULTADO_CLAVE / 2);
        tvNumero[x].setTextColor(Color.BLACK);
        relativeLayout.addView(tvNumero[x]);
    }

    private void señalizaAcierto(int x) {
        tvAcierto[x] = new TextView(getApplicationContext());
        tvAcierto[x].setX(medidas.POSICION_X_LETRAS_RESULTADO_CLAVE
                + medidas.TAMAÑO_LETRAS_RESULTADO_CLAVE
                + x * medidas.ADICION_X_LETRAS_RESULTADO_CLAVE);
        tvAcierto[x].setY(medidas.POSICION_Y_LETRAS_RESULTADO_CLAVE
                + medidas.TAMAÑO_LETRAS_RESULTADO_CLAVE);
        tvAcierto[x].setText("  A");
        tvAcierto[x].setTextSize(medidas.TAMAÑO_LETRAS_RESULTADO_CLAVE / 2);
        tvAcierto[x].setTextColor(Color.RED);
        relativeLayout.addView(tvAcierto[x]);
    }

}
